# ExtensionsPrototype

Source:
  - constructors/extensions/prototype.js, line 8

### Classes

slDOMSet

### Members

#### (static) _ :ExtensionsPrototype.slDOM

Source:
  - dictionary.d.js, line 336

##### Type:

- ExtensionsPrototype.slDOM

#### (static) __ :ExtensionsPrototype.slDOMSet

Source:
  - dictionary.d.js, line 340

##### Type:

- ExtensionsPrototype.slDOMSet

#### (static) fn :object

Source:
  - constructors/extensions/prototype.js, line 17

##### Properties:

Name | Type | Description
--- | --- | ---
`window` | ExtensionsPrototype.WindowFunctions |
`mouse` | ExtensionsPrototype.MouseFunctions |
`getRandId` | ExtensionsPrototype.getRandId_1 | ExtensionsPrototype.getRandId_2 |

##### Type:

- object

#### (static) object :object

Source:
  - constructors/extensions/prototype.js, line 49

##### Properties:

Name | Type | Description
--- | --- | ---
`extend` | ExtensionsPrototype.ObjectExtend_1 | ExtensionsPrototype.ObjectExtend_2 |

##### Type:

- object

#### (static) slDOM :ExtensionsPrototype.slDOM

Source:
  - dictionary.d.js, line 328

##### Type:

- ExtensionsPrototype.slDOM

#### (static) slDOM_env :ExtensionsPrototype.slDOM_env

Source:
  - dictionary.d.js, line 332

##### Type:

- ExtensionsPrototype.slDOM_env

#### (static) string :object

Source:
  - constructors/extensions/prototype.js, line 56

##### Type:

- object

#### (static) WindowExtend :any

Source:
  - constructors/extensions/prototype.js, line 106

##### Type:

- any

##### Example

    window.addEvent(elem, type, handler);
    window.removeEvent(elem, type, handlerId);

    window.addEventListener(eventName, function (event) {});

### Type Definitions

#### getRandId_1(prefix, minimize)

Source:
  - constructors/extensions/prototype.js, line 137

##### Parameters:

Name | Type | Description
--- | --- | ---
`prefix` | string |
`minimize` | boolean |

#### getRandId_2(minimize)

Source:
  - constructors/extensions/prototype.js, line 143

##### Parameters:

Name | Type | Description
--- | --- | ---
`minimize` | boolean |

#### MouseFunctions

Source:
  - constructors/extensions/prototype.js, line 38

##### Properties:

Name | Type | Description
--- | --- | ---
`event` | external:MouseEvent |
`position` | ExtensionsPrototype.MousePosition |
`config` | object | ###### Properties
Name | Type | Description
--- | --- | ---
`tracking` | boolean |

##### Type:

- object

#### MousePosition(eventMouseMoveopt, contextopt) → {ExtensionsPrototype.MousePositionCache}

Source:
  - constructors/extensions/prototype.js, line 298

##### Parameters:

Name | Type | Attributes | Description
--- | --- | --- | ---
`eventMouseMove` | MouseEvent | <optional> |
`context` | object | <optional> | ###### Properties
Name | Type | Attributes | Description
--- | --- | --- | ---
`window` | object | <optional> |
`document` | object | <optional> |

##### Returns:

Type
  ExtensionsPrototype.MousePositionCache

#### MousePositionCache

Source:
  - constructors/extensions/prototype.js, line 290

##### Properties:

Name | Type | Description
--- | --- | ---
`x` | number |
`y` | number |
`xmax` | number |
`ymax` | number |

##### Type:

- object

#### ObjectExtend_1(object, options)

Source:
  - constructors/extensions/prototype.js, line 313

##### Parameters:

Name | Type | Description
--- | --- | ---
`object` | object |
`options` | object | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`value` | any |  |  |
`readonly` | boolean | <optional> | `false` |
`visible` | boolean | <optional> | `false` |
`config` | boolean | <optional> | `false` |

#### ObjectExtend_2(object, options)

Source:
  - constructors/extensions/prototype.js, line 323

##### Parameters:

Name | Type | Description
--- | --- | ---
`object` | object |
`options` | object | ###### Properties
Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`get` | function | <optional> |  |
`set` | function | <optional> |  |
`visible` | boolean | <optional> | `false` |
`config` | boolean | <optional> | `false` |

#### slDOM

Source:
  - dictionary.d.js, line 534

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`env` | slDOM_env |  |  | Environment Flags
`__` | function |  |  | if params is `true` then return document otherwise current HTMLElement
`a2D` | function |  |  | apply Css Transforms on elements
`opacity` | function |  |  | ( short form o ) change element opacity
`setE` | function |  |  | ( short form e ) set a HTMLElement or Create Element for slDOM Pointer
`sClass` | function |  |  | =slDOMlib.sClass;
`setArg` | function |  |  | ( short form A ) set Attributes to HTMLElement, arguments order: `[ attribute, value, attribute, value ... ]`
`adEto` | function |  |  | add current HTMLElement to other HTMLElement;
`putBfto` | function |  |  | insert current HTMLElement before other HTMLElement
`putAfto` | function |  |  | insert current HTMLElement after other HTMLElement
`putBf` | function |  |  | =slDOMlib.putBf;
`putAf` | function |  |  | =slDOMlib.putAf;
`addE` | function |  |  | =slDOMlib.addE;
`addB` | function |  |  | =slDOMlib.addB;
`addT` | function |  |  | ( short form t ) add text node to HTMLElement;
`nextTo` | function | <optional> | `1` | ( short form N ) moving pointer forward to N neighbors
`backTo` | function | <optional> | `1` | ( short form B ) moving pointer backward to N neighbors
`nUP` | function |  |  | ( short form is U ) goes up on level in doom
`nChild` | function |  |  | ( short form is C ) select the N th child element
`getParentN` | function |  |  | ( short form is P ) select the N th parent element
`clearE` | function |  |  | ( short form is d ) remove all childObjects from node
`delE` | function |  |  | remove HTMLElement from its Parent
`copyE` | function |  |  | =slDOMlib.copyE;
`getParentTag` | function |  |  | =slDOMlib.getParentTag;
`getByTag` | function |  |  | =slDOMlib.getByTag;
`getByQuery` | function |  |  | =slDOMlib.getByQuery;
`getById` | function |  |  | =slDOMlib.getById;
`getTags` | function |  |  | =slDOMlib.getTags;
`getTagsByQuery` | function |  |  | =slDOMlib.getTagsByQuery;
`triger` | function |  |  | ( short form T ) trigger / emit an event on HTMLElement
`getE` | function |  |  | ( short form _ ) return HTMLElement ; if argument[0] is ".tag" return HTMLElement's tagname ; if argument[0] is ".html" return HTML Content ; if argument[0] is ".text" return Text Content ; if argument[0] is "-attributeName" return HTMLElement's Attribute ; if argument[0] is "!attributeName" remove HTMLElement's Attribute
`setStyle` | function |  |  | ( short form f ) setting css proprieties to HTMLElement
`setVar` | function |  |  | ( short form V ) set dot property on HTMLElement
`setObjVar` | function |  |  | ( short form v ) setting attributes to HTMLElement
`setStyleSPEED` | function |  |  | ( short form F ) setting css proprieties to HTMLElement with normalizing values by adding units
`pagePXY` | function |  |  | ( short form PXY ) get element position on page
`in_e` | function |  |  | check if HTMLElement is still attached to DOM ( Document Object Manager )
`g_wh` | function |  |  | returns width and height of HTMLElement
`getLIST` | function |  |  | =slDOMlib.getLIST;
`toFunction` | function |  |  | =slDOMlib.toFunction;
`removeFromDOM` | function |  |  | ( short form free ) remove elements from DOM
`o` | function |  |  | ( short form opacity ) change element opacity
`E` | function |  |  | ( long form setE ) set a HTMLElement or Create Element for slDOM Pointer
`c` | * |  |  | =slDOMlib.sClass;
`attrs` | function |  |  | = slDOMlib.attrs;
`A` | * |  |  | =slDOMlib.setArg;
`Et` | * |  |  | =slDOMlib.adEto;
`Bt` | * |  |  | =slDOMlib.putBfto;
`At` | * |  |  | =slDOMlib.putAfto;
`pB` | * |  |  | =slDOMlib.putBf;
`pA` | * |  |  | =slDOMlib.putAf;
`e` | * |  |  | =slDOMlib.addE;
`b` | * |  |  | =slDOMlib.addB;
`t` | * |  |  | =slDOMlib.addT;
`N` | * |  |  | =slDOMlib.nextTo;
`B` | * |  |  | =slDOMlib.backTo;
`U` | * |  |  | =slDOMlib.nUP;
`C` | * |  |  | =slDOMlib.nChild;
`P` | * |  |  | =slDOMlib.getParentN;
`d` | * |  |  | =slDOMlib.clearE;
`D` | * |  |  | =slDOMlib.delE;
`X` | * |  |  | =slDOMlib.copyE;
`p` | * |  |  | =slDOMlib.getParentTag;
`S` | * |  |  | =slDOMlib.getByTag;
`Q` | * |  |  | =slDOMlib.getByQuery;
`I` | * |  |  | =slDOMlib.getById;
`s` | * |  |  | =slDOMlib.getTags;
`q` | * |  |  | =slDOMlib.getTagsByQuery;
`T` | * |  |  | =slDOMlib.triger;
`_` | * |  |  | =slDOMlib.getE;
`$` | * |  |  | =slDOMlib.getLIST;
`F` | * |  |  | =slDOMlib.setStyleSPEED;
`f` | * |  |  | =slDOMlib.setStyle;
`L` | * |  |  | =slDOMlib.getLIST;
`V` | * |  |  | =slDOMlib.setVar;
`v` | * |  |  | =slDOMlib.setObjVar;
`p` | * |  |  | =slDOMlib.setObjProto;
`PXY` | * |  |  | =slDOMlib.pagePosXY;
`i` | * |  |  | =slDOMlib.in_e;
`r` | * |  |  | =slDOMlib.g_wh;
`x` | * |  |  | =slDOMlib.toFunction;
`free` | function |  |  | = slDOMlib.removeFromDOM;
`is_free` | function |  |  | = slDOMlib.is_free;
`is_focused` | function |  |  | = slDOMlib.is_focused;
`is_inview` | function |  |  | = slDOMlib.elementInViewport;
`is_visible` | function |  |  | = slDOMlib.elementIsVisible;
`_normalizeCssValues` | * |  |  | = slDOMlib._normalizeCssValues;
`on` | * |  |  | = slDOMlib.on;
`off` | * |  |  | = slDOMlib.off;
`eventsCache` | function |  |  | = slDOMlib.eventsCache;

returns a pointer that walks over DOM and applying needed operations

##### Type:

- object

#### slDOM_env

Source:
  - dictionary.d.js, line 494

##### Properties:

Name | Type | Description
--- | --- | ---
`gecko` | boolean |
`old_ie` | boolean |
`ie_lt8` | boolean |
`ie_lt9` | boolean |
`ie_gt10` | boolean |
`ie` | boolean |
`webkit` | boolean |
`qtwebkit` | boolean |
`chrome` | boolean |
`opera` | boolean |
`firefox` | boolean |
`safari` | boolean |
`khtml` | boolean |
`mac_geLion` | boolean |
`mac_geMountainLion` | boolean |
`phantom` | boolean |
`ios` | boolean |
`mobile` | boolean |
`mac` | boolean |
`windows` | boolean |
`opera_version` | Array | null |
`flipCtrlCmd` | boolean |
`captureMiddleClick` | boolean |
`android` | boolean |
`android_version` | string | false |

#### slDOM_ObjectAttributes

Source:
  - dictionary.d.js, line 528

a list of proprieties mapped in a object, example: { fontSize: "10px", "white-space": "nowrap" }

##### Type:

- Object.<string, (string|number)>

#### slDOM_ObjectCSSProperties

Source:
  - dictionary.d.js, line 524

a list of proprieties mapped in a object, example: { fontSize: "10px", "white-space": "nowrap" }

##### Type:

- Object.<string, (string|number)>

#### WindowFunctions

Source:
  - constructors/extensions/prototype.js, line 26

##### Properties:

Name | Type | Attributes | Default | Description
--- | --- | --- | --- | ---
`sizeLimit` | object |  |  | ###### Properties
Name | Type | Description
--- | --- | ---
`min` | ExtensionsPrototype.windowSizeCache |
`max` | ExtensionsPrototype.windowSizeCache |
`refreshRate` | number | <optional> | `200` | how often to recalculate window size
`sizeActive` | ExtensionsPrototype.windowSizeActive |  |  |
`size` | ExtensionsPrototype.windowSize |  |  |

##### Type:

- object

#### windowSize() → {ExtensionsPrototype.windowSizeCache}

Source:
  - constructors/extensions/prototype.js, line 239

##### Properties:

Name | Type | Description
--- | --- | ---
`refreshed` | boolean |

##### Returns:

Type
  ExtensionsPrototype.windowSizeCache

#### windowSizeActive() → {ExtensionsPrototype.windowSizeCache}

Source:
  - constructors/extensions/prototype.js, line 225

##### Properties:

Name | Type | Description
--- | --- | ---
`refreshed` | boolean |

##### Returns:

Type
  ExtensionsPrototype.windowSizeCache

#### windowSizeCache

Source:
  - constructors/extensions/prototype.js, line 219

##### Properties:

Name | Type | Description
--- | --- | ---
`w` | number |
`h` | number |

##### Type:

- object